package com.example.switchyard.external_bpms_dependency;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.services.client.api.RemoteRestRuntimeFactory;
import org.switchyard.component.bean.Service;

@Service(MyService.class)
public class MyServiceBean implements MyService
{

	@Override
	public void hello()
	{
		System.out.println( "Hello!" );
		String userId = "babak";
		String password = "password1!";
		String applicationContext = "http://localhost:8180/business-central";
		String deploymentId = "com.redhat.bpms.examples:mortgage:1";

		Map<String, Object> vars = new HashMap<String, Object>();
		RuntimeEngine runtimeEngine = getRuntimeEngine( applicationContext, deploymentId, userId, password );
		KieSession kieSession = runtimeEngine.getKieSession();
		kieSession.startProcess( "com.redhat.bpms.examples.mortgage.TestProcess", vars );
	}

	private static RuntimeEngine getRuntimeEngine(String applicationContext, String deploymentId, String userId, String password)
	{
		try
		{
			URL jbpmURL = new URL( applicationContext );
			RemoteRestRuntimeFactory remoteRestSessionFactory = new RemoteRestRuntimeFactory( deploymentId, jbpmURL, userId, password );
			RuntimeEngine runtimeEngine = remoteRestSessionFactory.newRuntimeEngine();
			return runtimeEngine;
		}
		catch( MalformedURLException e )
		{
			throw new IllegalStateException( "This URL is always expected to be valid!", e );
		}
	}
}
